﻿using Blazor.Models;
using Blazor.Pages;
using Microsoft.AspNetCore.Components;
using System.Collections.ObjectModel;

namespace Blazor.Components
{
    partial class Inventory
    {
        public InventoryItem CurrentDragItem { get; set; }
        public ObservableCollection<InventoryAction> Actions { get; set; }

        public Inventory() 
        {
            Actions = new ObservableCollection<InventoryAction>();
        }
        public void update()
        {
            this.StateHasChanged();
        }

        [Parameter]
        public InventoryList inventory { get; set; }
        public void Add(Item item)
        /*peut être useless*/
        {
            if (item == null) return;
            foreach(InventoryItem element in inventory.inventoryItems)
            {
                if(item.Id == element.item.Id)
                {
                    if(element.Stack == element.item.StackSize)
                    {
                        addEnd(item);
                        this.StateHasChanged();
                        return;
                    }
                    else
                    {
                        element.Stack += 1;
                        this.StateHasChanged();
                        return;
                    }
                }
                if(element == null)
                {
                    element.item = item;
                    element.Stack = 1;
                    this.StateHasChanged();
                    return;
                }
            }
            /*Si c'est ici c'est que l'inventaire est plein jsais pas si il faut avertir le user*/
        }

        public void addEnd(Item item)
        /*peut être useless*/
        {
            int i = 0;
            while (inventory.inventoryItems[i]!=null)
            {
                i += 1;
            }
            if(i < InventoryList.size)
            {
                inventory.inventoryItems[i].item = item;
                inventory.inventoryItems[i].Stack = 1;
            }
            else
            {
                /*Inventaire plein même cas que la fonction add*/
            }
        }

        
    }
}
